float4x4 worldViewProj : WorldViewProjection;

texture diffuseTexture : Diffuse
<
	string ResourceName = "default_color.dds";
>;

float4 fadeColor : Diffuse
<
    string UIName = "Fade Color";
    string Object = "DirectionalLight";
> = {0.0f, 0.0f, 0.0f, 0.0f};

float fade 
<
    string UIWidget = "slider";
    float UIMin = 0.0;
    float UIMax = 1.0;
    float UIStep = 0.01;
    string UIName = "fade";
> = 0.5;

struct vertexInput {
	float3 hPosition : POSITION;
    float4 texCoordDiffuse	: TEXCOORD0;
};

struct vertexOutput {
    float4 hPosition : POSITION;
    float4 texCoordDiffuse	: TEXCOORD0;
};

sampler TextureSampler = sampler_state 
{
    texture = <diffuseTexture>;
    AddressU  = CLAMP;        
    AddressV  = CLAMP;
    AddressW  = CLAMP;
    MIPFILTER = LINEAR;
    MINFILTER = LINEAR;
    MAGFILTER = LINEAR;
};

vertexOutput VS_Textured( vertexInput IN)
{
    vertexOutput OUT;
    OUT.hPosition = mul( float4(IN.hPosition.xyz , 1.0) , worldViewProj);
    OUT.texCoordDiffuse = IN.texCoordDiffuse;
	return OUT;
}

float4 PS_Textured( vertexOutput IN): COLOR
{
  float4 diffuseTexture = tex2D( TextureSampler, IN.texCoordDiffuse );
  return lerp(diffuseTexture, fadeColor, fade);
}


//-----------------------------------
technique textured
{
    pass p0 
    {		
		PixelShader  = compile ps_1_1 PS_Textured();
		VertexShader  = compile vs_1_1 VS_Textured();
    }
}